# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .chat_group_user_task_request_body import ChatGroupUserTaskRequestBody


class ChatGroupUserTaskRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.task_id: Optional[str] = None
        self.request_body: Optional[ChatGroupUserTaskRequestBody] = None

    @staticmethod
    def builder() -> "ChatGroupUserTaskRequestBuilder":
        return ChatGroupUserTaskRequestBuilder()


class ChatGroupUserTaskRequestBuilder(object):

    def __init__(self) -> None:
        chat_group_user_task_request = ChatGroupUserTaskRequest()
        chat_group_user_task_request.http_method = HttpMethod.POST
        chat_group_user_task_request.uri = "/open-apis/apaas/v1/user_tasks/:task_id/chat_group"
        chat_group_user_task_request.token_types = {AccessTokenType.TENANT}
        self._chat_group_user_task_request: ChatGroupUserTaskRequest = chat_group_user_task_request

    def task_id(self, task_id: str) -> "ChatGroupUserTaskRequestBuilder":
        self._chat_group_user_task_request.task_id = task_id
        self._chat_group_user_task_request.paths["task_id"] = str(task_id)
        return self

    def request_body(self, request_body: ChatGroupUserTaskRequestBody) -> "ChatGroupUserTaskRequestBuilder":
        self._chat_group_user_task_request.request_body = request_body
        self._chat_group_user_task_request.body = request_body
        return self

    def build(self) -> ChatGroupUserTaskRequest:
        return self._chat_group_user_task_request
