# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType


class ListSeatActivityRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.seat_type: Optional[str] = None
        self.page_size: Optional[str] = None
        self.page_token: Optional[str] = None

    @staticmethod
    def builder() -> "ListSeatActivityRequestBuilder":
        return ListSeatActivityRequestBuilder()


class ListSeatActivityRequestBuilder(object):

    def __init__(self) -> None:
        list_seat_activity_request = ListSeatActivityRequest()
        list_seat_activity_request.http_method = HttpMethod.GET
        list_seat_activity_request.uri = "/open-apis/apaas/v1/seat_activities"
        list_seat_activity_request.token_types = {AccessTokenType.USER}
        self._list_seat_activity_request: ListSeatActivityRequest = list_seat_activity_request

    def seat_type(self, seat_type: str) -> "ListSeatActivityRequestBuilder":
        self._list_seat_activity_request.seat_type = seat_type
        self._list_seat_activity_request.add_query("seat_type", seat_type)
        return self

    def page_size(self, page_size: str) -> "ListSeatActivityRequestBuilder":
        self._list_seat_activity_request.page_size = page_size
        self._list_seat_activity_request.add_query("page_size", page_size)
        return self

    def page_token(self, page_token: str) -> "ListSeatActivityRequestBuilder":
        self._list_seat_activity_request.page_token = page_token
        self._list_seat_activity_request.add_query("page_token", page_token)
        return self

    def build(self) -> ListSeatActivityRequest:
        return self._list_seat_activity_request
