# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .patch_application_object_record_request_body import PatchApplicationObjectRecordRequestBody


class PatchApplicationObjectRecordRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.namespace: Optional[str] = None
        self.object_api_name: Optional[str] = None
        self.id: Optional[str] = None
        self.request_body: Optional[PatchApplicationObjectRecordRequestBody] = None

    @staticmethod
    def builder() -> "PatchApplicationObjectRecordRequestBuilder":
        return PatchApplicationObjectRecordRequestBuilder()


class PatchApplicationObjectRecordRequestBuilder(object):

    def __init__(self) -> None:
        patch_application_object_record_request = PatchApplicationObjectRecordRequest()
        patch_application_object_record_request.http_method = HttpMethod.PATCH
        patch_application_object_record_request.uri = "/open-apis/apaas/v1/applications/:namespace/objects/:object_api_name/records/:id"
        patch_application_object_record_request.token_types = {AccessTokenType.TENANT}
        self._patch_application_object_record_request: PatchApplicationObjectRecordRequest = patch_application_object_record_request

    def namespace(self, namespace: str) -> "PatchApplicationObjectRecordRequestBuilder":
        self._patch_application_object_record_request.namespace = namespace
        self._patch_application_object_record_request.paths["namespace"] = str(namespace)
        return self

    def object_api_name(self, object_api_name: str) -> "PatchApplicationObjectRecordRequestBuilder":
        self._patch_application_object_record_request.object_api_name = object_api_name
        self._patch_application_object_record_request.paths["object_api_name"] = str(object_api_name)
        return self

    def id(self, id: str) -> "PatchApplicationObjectRecordRequestBuilder":
        self._patch_application_object_record_request.id = id
        self._patch_application_object_record_request.paths["id"] = str(id)
        return self

    def request_body(self,
                     request_body: PatchApplicationObjectRecordRequestBody) -> "PatchApplicationObjectRecordRequestBuilder":
        self._patch_application_object_record_request.request_body = request_body
        self._patch_application_object_record_request.body = request_body
        return self

    def build(self) -> PatchApplicationObjectRecordRequest:
        return self._patch_application_object_record_request
