# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .update_application_owner_request_body import UpdateApplicationOwnerRequestBody


class UpdateApplicationOwnerRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.user_id_type: Optional[str] = None
        self.app_id: Optional[str] = None
        self.request_body: Optional[UpdateApplicationOwnerRequestBody] = None

    @staticmethod
    def builder() -> "UpdateApplicationOwnerRequestBuilder":
        return UpdateApplicationOwnerRequestBuilder()


class UpdateApplicationOwnerRequestBuilder(object):

    def __init__(self) -> None:
        update_application_owner_request = UpdateApplicationOwnerRequest()
        update_application_owner_request.http_method = HttpMethod.PUT
        update_application_owner_request.uri = "/open-apis/application/v6/applications/:app_id/owner"
        update_application_owner_request.token_types = {AccessTokenType.TENANT, AccessTokenType.USER}
        self._update_application_owner_request: UpdateApplicationOwnerRequest = update_application_owner_request

    def user_id_type(self, user_id_type: str) -> "UpdateApplicationOwnerRequestBuilder":
        self._update_application_owner_request.user_id_type = user_id_type
        self._update_application_owner_request.add_query("user_id_type", user_id_type)
        return self

    def app_id(self, app_id: str) -> "UpdateApplicationOwnerRequestBuilder":
        self._update_application_owner_request.app_id = app_id
        self._update_application_owner_request.paths["app_id"] = str(app_id)
        return self

    def request_body(self, request_body: UpdateApplicationOwnerRequestBody) -> "UpdateApplicationOwnerRequestBuilder":
        self._update_application_owner_request.request_body = request_body
        self._update_application_owner_request.body = request_body
        return self

    def build(self) -> UpdateApplicationOwnerRequest:
        return self._update_application_owner_request
