# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType


class QueryRecentChangeCostCenterRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.page_size: Optional[int] = None
        self.page_token: Optional[str] = None
        self.start_date: Optional[str] = None
        self.end_date: Optional[str] = None

    @staticmethod
    def builder() -> "QueryRecentChangeCostCenterRequestBuilder":
        return QueryRecentChangeCostCenterRequestBuilder()


class QueryRecentChangeCostCenterRequestBuilder(object):

    def __init__(self) -> None:
        query_recent_change_cost_center_request = QueryRecentChangeCostCenterRequest()
        query_recent_change_cost_center_request.http_method = HttpMethod.GET
        query_recent_change_cost_center_request.uri = "/open-apis/corehr/v2/cost_centers/query_recent_change"
        query_recent_change_cost_center_request.token_types = {AccessTokenType.TENANT}
        self._query_recent_change_cost_center_request: QueryRecentChangeCostCenterRequest = query_recent_change_cost_center_request

    def page_size(self, page_size: int) -> "QueryRecentChangeCostCenterRequestBuilder":
        self._query_recent_change_cost_center_request.page_size = page_size
        self._query_recent_change_cost_center_request.add_query("page_size", page_size)
        return self

    def page_token(self, page_token: str) -> "QueryRecentChangeCostCenterRequestBuilder":
        self._query_recent_change_cost_center_request.page_token = page_token
        self._query_recent_change_cost_center_request.add_query("page_token", page_token)
        return self

    def start_date(self, start_date: str) -> "QueryRecentChangeCostCenterRequestBuilder":
        self._query_recent_change_cost_center_request.start_date = start_date
        self._query_recent_change_cost_center_request.add_query("start_date", start_date)
        return self

    def end_date(self, end_date: str) -> "QueryRecentChangeCostCenterRequestBuilder":
        self._query_recent_change_cost_center_request.end_date = end_date
        self._query_recent_change_cost_center_request.add_query("end_date", end_date)
        return self

    def build(self) -> QueryRecentChangeCostCenterRequest:
        return self._query_recent_change_cost_center_request
