# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType


class ListDatasourceRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.page_size: Optional[int] = None
        self.page_token: Optional[str] = None

    @staticmethod
    def builder() -> "ListDatasourceRequestBuilder":
        return ListDatasourceRequestBuilder()


class ListDatasourceRequestBuilder(object):

    def __init__(self) -> None:
        list_datasource_request = ListDatasourceRequest()
        list_datasource_request.http_method = HttpMethod.GET
        list_datasource_request.uri = "/open-apis/payroll/v1/datasources"
        list_datasource_request.token_types = {AccessTokenType.USER, AccessTokenType.TENANT}
        self._list_datasource_request: ListDatasourceRequest = list_datasource_request

    def page_size(self, page_size: int) -> "ListDatasourceRequestBuilder":
        self._list_datasource_request.page_size = page_size
        self._list_datasource_request.add_query("page_size", page_size)
        return self

    def page_token(self, page_token: str) -> "ListDatasourceRequestBuilder":
        self._list_datasource_request.page_token = page_token
        self._list_datasource_request.add_query("page_token", page_token)
        return self

    def build(self) -> ListDatasourceRequest:
        return self._list_datasource_request
