# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType


class ListPaygroupRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.page_size: Optional[int] = None
        self.page_token: Optional[str] = None

    @staticmethod
    def builder() -> "ListPaygroupRequestBuilder":
        return ListPaygroupRequestBuilder()


class ListPaygroupRequestBuilder(object):

    def __init__(self) -> None:
        list_paygroup_request = ListPaygroupRequest()
        list_paygroup_request.http_method = HttpMethod.GET
        list_paygroup_request.uri = "/open-apis/payroll/v1/paygroups"
        list_paygroup_request.token_types = {AccessTokenType.TENANT}
        self._list_paygroup_request: ListPaygroupRequest = list_paygroup_request

    def page_size(self, page_size: int) -> "ListPaygroupRequestBuilder":
        self._list_paygroup_request.page_size = page_size
        self._list_paygroup_request.add_query("page_size", page_size)
        return self

    def page_token(self, page_token: str) -> "ListPaygroupRequestBuilder":
        self._list_paygroup_request.page_token = page_token
        self._list_paygroup_request.add_query("page_token", page_token)
        return self

    def build(self) -> ListPaygroupRequest:
        return self._list_paygroup_request
