# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.construct import init
from .i18n import I18n
from .country_region import CountryRegion


class Paygroup(object):
    _types = {
        "pay_group_id": str,
        "name": I18n,
        "code": str,
        "status": int,
        "country_region": CountryRegion,
    }

    def __init__(self, d=None):
        self.pay_group_id: Optional[str] = None
        self.name: Optional[I18n] = None
        self.code: Optional[str] = None
        self.status: Optional[int] = None
        self.country_region: Optional[CountryRegion] = None
        init(self, d, self._types)

    @staticmethod
    def builder() -> "PaygroupBuilder":
        return PaygroupBuilder()


class PaygroupBuilder(object):
    def __init__(self) -> None:
        self._paygroup = Paygroup()

    def pay_group_id(self, pay_group_id: str) -> "PaygroupBuilder":
        self._paygroup.pay_group_id = pay_group_id
        return self

    def name(self, name: I18n) -> "PaygroupBuilder":
        self._paygroup.name = name
        return self

    def code(self, code: str) -> "PaygroupBuilder":
        self._paygroup.code = code
        return self

    def status(self, status: int) -> "PaygroupBuilder":
        self._paygroup.status = status
        return self

    def country_region(self, country_region: CountryRegion) -> "PaygroupBuilder":
        self._paygroup.country_region = country_region
        return self

    def build(self) -> "Paygroup":
        return self._paygroup
