# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .query_datasource_record_request_body import QueryDatasourceRecordRequestBody


class QueryDatasourceRecordRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.page_size: Optional[int] = None
        self.page_token: Optional[str] = None
        self.request_body: Optional[QueryDatasourceRecordRequestBody] = None

    @staticmethod
    def builder() -> "QueryDatasourceRecordRequestBuilder":
        return QueryDatasourceRecordRequestBuilder()


class QueryDatasourceRecordRequestBuilder(object):

    def __init__(self) -> None:
        query_datasource_record_request = QueryDatasourceRecordRequest()
        query_datasource_record_request.http_method = HttpMethod.POST
        query_datasource_record_request.uri = "/open-apis/payroll/v1/datasource_records/query"
        query_datasource_record_request.token_types = {AccessTokenType.USER, AccessTokenType.TENANT}
        self._query_datasource_record_request: QueryDatasourceRecordRequest = query_datasource_record_request

    def page_size(self, page_size: int) -> "QueryDatasourceRecordRequestBuilder":
        self._query_datasource_record_request.page_size = page_size
        self._query_datasource_record_request.add_query("page_size", page_size)
        return self

    def page_token(self, page_token: str) -> "QueryDatasourceRecordRequestBuilder":
        self._query_datasource_record_request.page_token = page_token
        self._query_datasource_record_request.add_query("page_token", page_token)
        return self

    def request_body(self, request_body: QueryDatasourceRecordRequestBody) -> "QueryDatasourceRecordRequestBuilder":
        self._query_datasource_record_request.request_body = request_body
        self._query_datasource_record_request.body = request_body
        return self

    def build(self) -> QueryDatasourceRecordRequest:
        return self._query_datasource_record_request
