# Code generated by Lark OpenAPI.

import io
from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.const import UTF_8, CONTENT_TYPE, APPLICATION_JSON
from lark_oapi.core import JSON
from lark_oapi.core.token import verify
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.utils import Files
from requests_toolbelt import MultipartEncoder
from ..model.archive_payment_activity_request import ArchivePaymentActivityRequest
from ..model.archive_payment_activity_response import ArchivePaymentActivityResponse
from ..model.list_payment_activity_request import ListPaymentActivityRequest
from ..model.list_payment_activity_response import ListPaymentActivityResponse


class PaymentActivity(object):
    def __init__(self, config: Config) -> None:
        self.config: Config = config

    def archive(self, request: ArchivePaymentActivityRequest,
                option: Optional[RequestOption] = None) -> ArchivePaymentActivityResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: ArchivePaymentActivityResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                  ArchivePaymentActivityResponse)
        response.raw = resp

        return response

    async def aarchive(self, request: ArchivePaymentActivityRequest,
                       option: Optional[RequestOption] = None) -> ArchivePaymentActivityResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: ArchivePaymentActivityResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                  ArchivePaymentActivityResponse)
        response.raw = resp

        return response

    def list(self, request: ListPaymentActivityRequest,
             option: Optional[RequestOption] = None) -> ListPaymentActivityResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: ListPaymentActivityResponse = JSON.unmarshal(str(resp.content, UTF_8), ListPaymentActivityResponse)
        response.raw = resp

        return response

    async def alist(self, request: ListPaymentActivityRequest,
                    option: Optional[RequestOption] = None) -> ListPaymentActivityResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: ListPaymentActivityResponse = JSON.unmarshal(str(resp.content, UTF_8), ListPaymentActivityResponse)
        response.raw = resp

        return response
