# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .import_metric_detail_request_body import ImportMetricDetailRequestBody


class ImportMetricDetailRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.client_token: Optional[str] = None
        self.user_id_type: Optional[str] = None
        self.request_body: Optional[ImportMetricDetailRequestBody] = None

    @staticmethod
    def builder() -> "ImportMetricDetailRequestBuilder":
        return ImportMetricDetailRequestBuilder()


class ImportMetricDetailRequestBuilder(object):

    def __init__(self) -> None:
        import_metric_detail_request = ImportMetricDetailRequest()
        import_metric_detail_request.http_method = HttpMethod.POST
        import_metric_detail_request.uri = "/open-apis/performance/v2/metric_details/import"
        import_metric_detail_request.token_types = {AccessTokenType.TENANT}
        self._import_metric_detail_request: ImportMetricDetailRequest = import_metric_detail_request

    def client_token(self, client_token: str) -> "ImportMetricDetailRequestBuilder":
        self._import_metric_detail_request.client_token = client_token
        self._import_metric_detail_request.add_query("client_token", client_token)
        return self

    def user_id_type(self, user_id_type: str) -> "ImportMetricDetailRequestBuilder":
        self._import_metric_detail_request.user_id_type = user_id_type
        self._import_metric_detail_request.add_query("user_id_type", user_id_type)
        return self

    def request_body(self, request_body: ImportMetricDetailRequestBody) -> "ImportMetricDetailRequestBuilder":
        self._import_metric_detail_request.request_body = request_body
        self._import_metric_detail_request.body = request_body
        return self

    def build(self) -> ImportMetricDetailRequest:
        return self._import_metric_detail_request
