# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType


class ListMetricTagRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.page_size: Optional[int] = None
        self.page_token: Optional[str] = None
        self.tag_ids: Optional[List[str]] = None

    @staticmethod
    def builder() -> "ListMetricTagRequestBuilder":
        return ListMetricTagRequestBuilder()


class ListMetricTagRequestBuilder(object):

    def __init__(self) -> None:
        list_metric_tag_request = ListMetricTagRequest()
        list_metric_tag_request.http_method = HttpMethod.GET
        list_metric_tag_request.uri = "/open-apis/performance/v2/metric_tags"
        list_metric_tag_request.token_types = {AccessTokenType.TENANT}
        self._list_metric_tag_request: ListMetricTagRequest = list_metric_tag_request

    def page_size(self, page_size: int) -> "ListMetricTagRequestBuilder":
        self._list_metric_tag_request.page_size = page_size
        self._list_metric_tag_request.add_query("page_size", page_size)
        return self

    def page_token(self, page_token: str) -> "ListMetricTagRequestBuilder":
        self._list_metric_tag_request.page_token = page_token
        self._list_metric_tag_request.add_query("page_token", page_token)
        return self

    def tag_ids(self, tag_ids: List[str]) -> "ListMetricTagRequestBuilder":
        self._list_metric_tag_request.tag_ids = tag_ids
        self._list_metric_tag_request.add_query("tag_ids", tag_ids)
        return self

    def build(self) -> ListMetricTagRequest:
        return self._list_metric_tag_request
