# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .query_question_request_body import QueryQuestionRequestBody


class QueryQuestionRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.page_token: Optional[str] = None
        self.page_size: Optional[int] = None
        self.request_body: Optional[QueryQuestionRequestBody] = None

    @staticmethod
    def builder() -> "QueryQuestionRequestBuilder":
        return QueryQuestionRequestBuilder()


class QueryQuestionRequestBuilder(object):

    def __init__(self) -> None:
        query_question_request = QueryQuestionRequest()
        query_question_request.http_method = HttpMethod.POST
        query_question_request.uri = "/open-apis/performance/v2/questions/query"
        query_question_request.token_types = {AccessTokenType.TENANT}
        self._query_question_request: QueryQuestionRequest = query_question_request

    def page_token(self, page_token: str) -> "QueryQuestionRequestBuilder":
        self._query_question_request.page_token = page_token
        self._query_question_request.add_query("page_token", page_token)
        return self

    def page_size(self, page_size: int) -> "QueryQuestionRequestBuilder":
        self._query_question_request.page_size = page_size
        self._query_question_request.add_query("page_size", page_size)
        return self

    def request_body(self, request_body: QueryQuestionRequestBody) -> "QueryQuestionRequestBuilder":
        self._query_question_request.request_body = request_body
        self._query_question_request.body = request_body
        return self

    def build(self) -> QueryQuestionRequest:
        return self._query_question_request
