# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.model import BaseRequest
from lark_oapi.core.enum import HttpMethod, AccessTokenType
from .query_review_data_request_body import QueryReviewDataRequestBody


class QueryReviewDataRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.user_id_type: Optional[str] = None
        self.request_body: Optional[QueryReviewDataRequestBody] = None

    @staticmethod
    def builder() -> "QueryReviewDataRequestBuilder":
        return QueryReviewDataRequestBuilder()


class QueryReviewDataRequestBuilder(object):

    def __init__(self) -> None:
        query_review_data_request = QueryReviewDataRequest()
        query_review_data_request.http_method = HttpMethod.POST
        query_review_data_request.uri = "/open-apis/performance/v2/review_datas/query"
        query_review_data_request.token_types = {AccessTokenType.TENANT}
        self._query_review_data_request: QueryReviewDataRequest = query_review_data_request

    def user_id_type(self, user_id_type: str) -> "QueryReviewDataRequestBuilder":
        self._query_review_data_request.user_id_type = user_id_type
        self._query_review_data_request.add_query("user_id_type", user_id_type)
        return self

    def request_body(self, request_body: QueryReviewDataRequestBody) -> "QueryReviewDataRequestBuilder":
        self._query_review_data_request.request_body = request_body
        self._query_review_data_request.body = request_body
        return self

    def build(self) -> QueryReviewDataRequest:
        return self._query_review_data_request
