# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.construct import init
from .user import User
from .review_stage import ReviewStage


class ReviewProfile(object):
    _types = {
        "user_id": User,
        "semester_id": str,
        "activity_id": str,
        "review_template_id": str,
        "stages": List[ReviewStage],
    }

    def __init__(self, d=None):
        self.user_id: Optional[User] = None
        self.semester_id: Optional[str] = None
        self.activity_id: Optional[str] = None
        self.review_template_id: Optional[str] = None
        self.stages: Optional[List[ReviewStage]] = None
        init(self, d, self._types)

    @staticmethod
    def builder() -> "ReviewProfileBuilder":
        return ReviewProfileBuilder()


class ReviewProfileBuilder(object):
    def __init__(self) -> None:
        self._review_profile = ReviewProfile()

    def user_id(self, user_id: User) -> "ReviewProfileBuilder":
        self._review_profile.user_id = user_id
        return self

    def semester_id(self, semester_id: str) -> "ReviewProfileBuilder":
        self._review_profile.semester_id = semester_id
        return self

    def activity_id(self, activity_id: str) -> "ReviewProfileBuilder":
        self._review_profile.activity_id = activity_id
        return self

    def review_template_id(self, review_template_id: str) -> "ReviewProfileBuilder":
        self._review_profile.review_template_id = review_template_id
        return self

    def stages(self, stages: List[ReviewStage]) -> "ReviewProfileBuilder":
        self._review_profile.stages = stages
        return self

    def build(self) -> "ReviewProfile":
        return self._review_profile
