# Code generated by Lark OpenAPI.

import io
from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.const import UTF_8, CONTENT_TYPE, APPLICATION_JSON
from lark_oapi.core import JSON
from lark_oapi.core.token import verify
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.utils import Files
from requests_toolbelt import MultipartEncoder
from ..model.import_additional_information_request import ImportAdditionalInformationRequest
from ..model.import_additional_information_response import ImportAdditionalInformationResponse
from ..model.query_additional_information_request import QueryAdditionalInformationRequest
from ..model.query_additional_information_response import QueryAdditionalInformationResponse


class AdditionalInformation(object):
    def __init__(self, config: Config) -> None:
        self.config: Config = config

    def import_(self, request: ImportAdditionalInformationRequest,
                option: Optional[RequestOption] = None) -> ImportAdditionalInformationResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: ImportAdditionalInformationResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                       ImportAdditionalInformationResponse)
        response.raw = resp

        return response

    async def aimport_(self, request: ImportAdditionalInformationRequest,
                       option: Optional[RequestOption] = None) -> ImportAdditionalInformationResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: ImportAdditionalInformationResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                       ImportAdditionalInformationResponse)
        response.raw = resp

        return response

    def query(self, request: QueryAdditionalInformationRequest,
              option: Optional[RequestOption] = None) -> QueryAdditionalInformationResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: QueryAdditionalInformationResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                      QueryAdditionalInformationResponse)
        response.raw = resp

        return response

    async def aquery(self, request: QueryAdditionalInformationRequest,
                     option: Optional[RequestOption] = None) -> QueryAdditionalInformationResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: QueryAdditionalInformationResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                      QueryAdditionalInformationResponse)
        response.raw = resp

        return response
