# Code generated by Lark OpenAPI.

import io
from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.const import UTF_8, CONTENT_TYPE, APPLICATION_JSON
from lark_oapi.core import JSON
from lark_oapi.core.token import verify
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.utils import Files
from requests_toolbelt import MultipartEncoder
from ..model.import_metric_detail_request import ImportMetricDetailRequest
from ..model.import_metric_detail_response import ImportMetricDetailResponse
from ..model.query_metric_detail_request import QueryMetricDetailRequest
from ..model.query_metric_detail_response import QueryMetricDetailResponse


class MetricDetail(object):
    def __init__(self, config: Config) -> None:
        self.config: Config = config

    def import_(self, request: ImportMetricDetailRequest,
                option: Optional[RequestOption] = None) -> ImportMetricDetailResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: ImportMetricDetailResponse = JSON.unmarshal(str(resp.content, UTF_8), ImportMetricDetailResponse)
        response.raw = resp

        return response

    async def aimport_(self, request: ImportMetricDetailRequest,
                       option: Optional[RequestOption] = None) -> ImportMetricDetailResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: ImportMetricDetailResponse = JSON.unmarshal(str(resp.content, UTF_8), ImportMetricDetailResponse)
        response.raw = resp

        return response

    def query(self, request: QueryMetricDetailRequest,
              option: Optional[RequestOption] = None) -> QueryMetricDetailResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 添加 content-type
        if request.body is not None:
            option.headers[CONTENT_TYPE] = f"{APPLICATION_JSON}; charset=utf-8"

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: QueryMetricDetailResponse = JSON.unmarshal(str(resp.content, UTF_8), QueryMetricDetailResponse)
        response.raw = resp

        return response

    async def aquery(self, request: QueryMetricDetailRequest,
                     option: Optional[RequestOption] = None) -> QueryMetricDetailResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取 token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = await Transport.aexecute(self.config, request, option)

        # 反序列化
        response: QueryMetricDetailResponse = JSON.unmarshal(str(resp.content, UTF_8), QueryMetricDetailResponse)
        response.raw = resp

        return response
