# Code generated by Lark OpenAPI.

from typing import Any, Optional, Union, Dict, List, Set, IO, Callable, Type
from lark_oapi.core.construct import init
from .enterprise_knowledge_source_param import EnterpriseKnowledgeSourceParam
from .knowledge_source_request_extra import KnowledgeSourceRequestExtra


class KnowledgeSourceAnswerRequest(object):
    _types = {
        "query": str,
        "enable_image": bool,
        "knowledge_scope": str,
        "enterprise_knowledge_source": EnterpriseKnowledgeSourceParam,
        "extra": KnowledgeSourceRequestExtra,
    }

    def __init__(self, d=None):
        self.query: Optional[str] = None
        self.enable_image: Optional[bool] = None
        self.knowledge_scope: Optional[str] = None
        self.enterprise_knowledge_source: Optional[EnterpriseKnowledgeSourceParam] = None
        self.extra: Optional[KnowledgeSourceRequestExtra] = None
        init(self, d, self._types)

    @staticmethod
    def builder() -> "KnowledgeSourceAnswerRequestBuilder":
        return KnowledgeSourceAnswerRequestBuilder()


class KnowledgeSourceAnswerRequestBuilder(object):
    def __init__(self) -> None:
        self._knowledge_source_answer_request = KnowledgeSourceAnswerRequest()

    def query(self, query: str) -> "KnowledgeSourceAnswerRequestBuilder":
        self._knowledge_source_answer_request.query = query
        return self

    def enable_image(self, enable_image: bool) -> "KnowledgeSourceAnswerRequestBuilder":
        self._knowledge_source_answer_request.enable_image = enable_image
        return self

    def knowledge_scope(self, knowledge_scope: str) -> "KnowledgeSourceAnswerRequestBuilder":
        self._knowledge_source_answer_request.knowledge_scope = knowledge_scope
        return self

    def enterprise_knowledge_source(self,
                                    enterprise_knowledge_source: EnterpriseKnowledgeSourceParam) -> "KnowledgeSourceAnswerRequestBuilder":
        self._knowledge_source_answer_request.enterprise_knowledge_source = enterprise_knowledge_source
        return self

    def extra(self, extra: KnowledgeSourceRequestExtra) -> "KnowledgeSourceAnswerRequestBuilder":
        self._knowledge_source_answer_request.extra = extra
        return self

    def build(self) -> "KnowledgeSourceAnswerRequest":
        return self._knowledge_source_answer_request
